# Fingerbank Collector

## Introduction

The Fingerbank Collector allows network and security vendors to easily integrate advanced device fingerprinting and profiling technologies within their product. Firewalls, access points, WiFi controllers, switches, proxies and other solutions can integrate the Fingerbank Collector in order to accurately identify endpoints on networks. These solutions can then apply network and security policies based on the device type. With the proliferation of IoT devices, the Fingerbank Collector is essential to increase awareness and thus, security.

## Setup

First, download Golang 1.16.4 and install it on your system. Other versions above 1.13 should work fine but this was tested against 1.16.4

Next, install the libpcap headers (`libpcap-dev` on Debian/Ubuntu, `libpcap-devel` on RHEL)

You will need to setup your .netrc to include your credentials to git.inverse.ca like so:

```
# echo "machine git.inverse.ca login elzammito password bob" > ~/.netrc
```

Next, instruct Golang to consider git.inverse.ca as a private repo:

```
# go env -w GOPRIVATE=git.inverse.ca
```

You should now be ready to compile the binary (dependencies will be pulled during the build)

```
# make fingerbank-collector
```

