#!/usr/bin/perl

use strict;
use warnings;

use File::Slurp qw(read_file);
use JSON;
use Data::Dumper;
use List::MoreUtils qw(uniq);

my $content = read_file($ARGV[0]);
my $json = decode_json($content);

my $data = {
    upnp_user_agents => [],
    upnp_server_strings => [],
    mdns_services => [],
};

foreach my $ed (@$json) {
#    print Dumper($ed->{upnp_user_agents}) if(scalar(keys(%{$ed->{upnp_user_agents}})) > 0);

    foreach my $attr (keys(%$data)) {
        if(scalar(keys(%{$ed->{$attr}})) > 0) {
            push @{$data->{$attr}}, keys(%{$ed->{$attr}});
        }
    }
}

foreach my $attr (keys(%$data)) {
	$data->{$attr} = [ uniq @{$data->{$attr}} ];
}

print Dumper($data);

