package fccommon

import "sort"

func RankByWordCount(wordFrequencies map[string]int) PairList {
	pl := make(PairList, len(wordFrequencies))
	i := 0
	for k, v := range wordFrequencies {
		pl[i] = Pair{k, v}
		i++
	}
	sort.Sort(sort.Reverse(pl))
	return pl
}

func RankByWordCountMapStringMapStringInt(data map[string]map[string]int) PairList {
	pl := make(PairList, len(data))
	i := 0
	for k, v := range data {
		total := 0
		for _, v2 := range v {
			total += v2
		}
		pl[i] = Pair{k, total}
		i++
	}
	sort.Sort(sort.Reverse(pl))
	return pl
}

type Pair struct {
	Key   string
	Value int
}

type PairList []Pair

func (p PairList) Len() int           { return len(p) }
func (p PairList) Less(i, j int) bool { return p[i].Value < p[j].Value }
func (p PairList) Swap(i, j int)      { p[i], p[j] = p[j], p[i] }

func RankByWordCountMapIntInt(wordFrequencies map[int]int) IntPairList {
	pl := make(IntPairList, len(wordFrequencies))
	i := 0
	for k, v := range wordFrequencies {
		pl[i] = IntPair{k, v}
		i++
	}
	sort.Sort(sort.Reverse(pl))
	return pl
}

type IntPair struct {
	Key   int
	Value int
}

type IntPairList []IntPair

func (p IntPairList) Len() int           { return len(p) }
func (p IntPairList) Less(i, j int) bool { return p[i].Value < p[j].Value }
func (p IntPairList) Swap(i, j int)      { p[i], p[j] = p[j], p[i] }
