package main

import (
	"fmt"
	"net"
	"time"

	"github.com/google/uuid"

	"git.inverse.ca/inverse/fingerbank-collector/common/replication"
)

func main() {
	myuuid := uuid.New()
	ctrl := fcreplication.NewController(myuuid, []byte("1234567890123456"), []net.IP{}, true)

	ctrl.StartReplication()

	ctrl.ActionMap[fcreplication.REP_ENDPOINT_DATA_UPDATE] = func(request interface{}) fcreplication.ReplicationMessage {
		fmt.Println("Handling endpoint update")
		return fcreplication.ReplicationMessage{}
	}

	// Send a test update every 2 seconds
	for {
		sendEndpointDataUpdate(ctrl)
		time.Sleep(2 * time.Second)
	}
}

func sendEndpointDataUpdate(ctrl *fcreplication.Controller) {
	pkt := fcreplication.REPEndpointDataUpdate{Timestamp: time.Now(), DeltaEndpointDataJSON: []byte(`{"dhcp_fingerprint":"192,168,5,3"}`)}
	ctrl.SendContentToOutboundFriends(fcreplication.REP_ENDPOINT_DATA_UPDATE, pkt)
}
