# Golang
GOVERSION = go1.18.9

# Fingerbank specific variables
FB_RELEASE = 1.4.2

# source dirs
# hack to get directory of config.mk from any Makefile in source tree
# even if make is called with -C
SRC_ROOT_DIR = $(realpath $(dir $(abspath $(lastword $(MAKEFILE_LIST)))))
SRC_RPM_DIR = $(SRC_ROOT_DIR)/rpm
SRC_DEB_DIR = $(SRC_ROOT_DIR)/debian
SRC_CONTAINERS_DIR = $(SRC_ROOT_DIR)/containers
SRC_CI_DIR = $(SRC_ROOT_DIR)/ci

# Containers
KNK_REGISTRY = ghcr.io
KNK_REGISTRY_URL = ghcr.io/akainverse/fingerbank-collector

# all directories and files to include in packetfence package
# $(SRC_ROOT_DIR)/* to exclude SRC_ROOT_DIR himself
files_to_include = $(shell find $(SRC_ROOT_DIR)/* \
	-maxdepth 0 \
	-not -path "$(SRC_ROOT_DIR)/fingerbank-collector-$(FB_RELEASE)" \
	-not -path "$(SRC_RPM_DIR)" \
	-not -path "$(SRC_CONTAINERS_DIR)" \
	-not -path "$(SRC_CI_DIR)" \
	-not -path "$(SRC_DEB_DIR)" )
