package dpi

import (
	"net"

	"github.com/google/gopacket"
)

type Metadata interface {
	GetSrcIP() net.IP
	GetSrcPort() uint16
	GetDstIP() net.IP
	GetDstPort() uint16
	GetProto() string
}

type Engine interface {
	ProcessPkt(metadata Metadata, gp gopacket.Packet, data []byte, info gopacket.CaptureInfo, linkType int)
	SetCallback(func(metadata Metadata, signatures []string))
	Destroy()
}
