// +build checksum_api_key

package keyoverride

import (
	"crypto/sha1"
	"fmt"
	"io"
	"os"

	"git.inverse.ca/inverse/fingerbank-collector/log"
)

var ID = ""
var logger = fclog.Logger("")

func init() {
	if ID == "" {
		panic("Binary identifier not set for CAK method")
	}

	logger.Info("Performing key override using CAK method")
}

func Override(key string) string {
	binPath := os.Args[0]
	f, err := os.Open(binPath)
	if err != nil {
		panic("Error while attempting to open current binary " + binPath + ": " + err.Error())
	}
	defer f.Close()

	h := sha1.New()
	if _, err := io.Copy(h, f); err != nil {
		panic("Error while determining CAK key: " + err.Error())
	}

	key = fmt.Sprintf("%x", h.Sum(nil))

	logger.Info("Your Fingerbank API key is: " + key)

	return key
}
